//
//  LocationAtShopVC.swift
//  Groceries
//
//  Created by Tim Roadley on 21/07/2015.
//  Copyright © 2015 Tim Roadley. All rights reserved.
//

import UIKit

class LocationAtShopVC: GenericVC, UITextFieldDelegate {

    @IBOutlet var nameTextField: UITextField!
    
    // MARK: - DELEGATE: UITextField
    func textFieldDidBeginEditing(textField: UITextField) {
    
        switch (textField) {
            case self.nameTextField:
        
                if self.nameTextField.text == "New Shop Location" {
                    self.nameTextField.text = ""
                }
            break;
        default:break;
        }
    }
    func textFieldDidEndEditing(textField: UITextField) {
        
        if let locationAtShop = self.selectedObject as? LocationAtShop {
            
            switch (textField) {
                case self.nameTextField:
                    if self.nameTextField.text == "" {
                        "New Shop Location"
                    }
                    locationAtShop.aisle = self.nameTextField.text
                    break;
                default:break;
            }
        } else {self.done()}
    }
    
    // MARK: - VIEW
    func refreshInterface () {
       
        if let locationAtShop = self.selectedObject as? LocationAtShop {
            
            locationAtShop.modified = NSDate()
            
            self.nameTextField.text = locationAtShop.aisle
        } else {self.done()}
    }
    override func viewDidLoad() {
        super.viewDidLoad()
        
        self.hideKeyboardWhenBackgroundIsTapped()
        self.nameTextField.delegate = self
        let doneButton = UIBarButtonItem(barButtonSystemItem: .Done, target: self, action: "done")
        self.navigationItem.rightBarButtonItem = doneButton
    }
    override func viewWillAppear(animated: Bool) {
        super.viewWillAppear(animated)
        
        self.refreshInterface()
        self.nameTextField.becomeFirstResponder()
    }
    override func viewDidDisappear(animated: Bool) {
        super.viewDidDisappear(animated)
        
        CDHelper.saveSharedContext()
        NSNotificationCenter.defaultCenter().postNotificationName("SomethingChanged", object: nil)
    }
}
