//
//  UnitVC.swift
//  Groceries
//
//  Created by Tim Roadley on 5/10/2015.
//  Copyright © 2015 Tim Roadley. All rights reserved.
//

import UIKit

class UnitVC: GenericVC, UITextFieldDelegate {

    @IBOutlet var nameTextField: UITextField!
    
    // MARK: - DELEGATE: UITextField
    func textFieldDidBeginEditing(textField: UITextField) {
    
        switch (textField) {
            case self.nameTextField:
        
                if self.nameTextField.text == "New Unit" {
                    self.nameTextField.text = ""
                }
            break;
        default:break;
        }
    }
    func textFieldDidEndEditing(textField: UITextField) {
        
        if let unit = self.selectedObject as? Unit {
            
            switch (textField) {
                case self.nameTextField:
                    if self.nameTextField.text == "" {
                        "New Unit"
                    }
                    unit.name = self.nameTextField.text
                    break;
                default:break;
            }
        } else {self.done()}
    }
    
    // MARK: - VIEW
    func refreshInterface () {
       
        if let unit = self.selectedObject as? Unit {
            
            unit.modified = NSDate()
            CDCloudSync.shared.setCacheStatusForObject(unit, requestedStatus: CHANGED)
            
            self.nameTextField.text = unit.name
        } else {self.done()}
    }
    override func viewDidLoad() {
        super.viewDidLoad()
        
        self.hideKeyboardWhenBackgroundIsTapped()
        self.nameTextField.delegate = self
        let doneButton = UIBarButtonItem(barButtonSystemItem: .Done, target: self, action: "done")
        self.navigationItem.rightBarButtonItem = doneButton
    }
    override func viewWillAppear(animated: Bool) {
        super.viewWillAppear(animated)
        
        self.refreshInterface()
        self.nameTextField.becomeFirstResponder()
    }
    override func viewDidDisappear(animated: Bool) {
        super.viewDidDisappear(animated)
        
        CDHelper.saveSharedContext()
        NSNotificationCenter.defaultCenter().postNotificationName("SomethingChanged", object: nil)
    }
}
